/* scaler.c generated by valac 0.38.8, the Vala compiler
 * generated from scaler.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <cairo.h>


#define PDFPC_TYPE_SCALER (pdfpc_scaler_get_type ())
#define PDFPC_SCALER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PDFPC_TYPE_SCALER, pdfpcScaler))
#define PDFPC_SCALER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PDFPC_TYPE_SCALER, pdfpcScalerClass))
#define PDFPC_IS_SCALER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PDFPC_TYPE_SCALER))
#define PDFPC_IS_SCALER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PDFPC_TYPE_SCALER))
#define PDFPC_SCALER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PDFPC_TYPE_SCALER, pdfpcScalerClass))

typedef struct _pdfpcScaler pdfpcScaler;
typedef struct _pdfpcScalerClass pdfpcScalerClass;
typedef struct _pdfpcScalerPrivate pdfpcScalerPrivate;
enum  {
	PDFPC_SCALER_0_PROPERTY,
	PDFPC_SCALER_NUM_PROPERTIES
};
static GParamSpec* pdfpc_scaler_properties[PDFPC_SCALER_NUM_PROPERTIES];

struct _pdfpcScaler {
	GObject parent_instance;
	pdfpcScalerPrivate * priv;
	gdouble initial_width;
	gdouble initial_height;
};

struct _pdfpcScalerClass {
	GObjectClass parent_class;
};


static gpointer pdfpc_scaler_parent_class = NULL;

GType pdfpc_scaler_get_type (void) G_GNUC_CONST;
pdfpcScaler* pdfpc_scaler_new (gdouble width, gdouble height);
pdfpcScaler* pdfpc_scaler_construct (GType object_type, gdouble width, gdouble height);
void pdfpc_scaler_scale_to (pdfpcScaler* self, gint width, gint height, gboolean centered, gboolean allow_cutoff, GdkRectangle* result);
static void pdfpc_scaler_finalize (GObject * obj);


/**
         * Create a new Scaler taking initial width and height as input
         */
pdfpcScaler* pdfpc_scaler_construct (GType object_type, gdouble width, gdouble height) {
	pdfpcScaler * self = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 46 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	self = (pdfpcScaler*) g_object_new (object_type, NULL);
#line 47 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp0_ = width;
#line 47 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	self->initial_width = _tmp0_;
#line 48 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp1_ = height;
#line 48 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	self->initial_height = _tmp1_;
#line 46 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	return self;
#line 71 "scaler.c"
}


pdfpcScaler* pdfpc_scaler_new (gdouble width, gdouble height) {
#line 46 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	return pdfpc_scaler_construct (PDFPC_TYPE_SCALER, width, height);
#line 78 "scaler.c"
}


/**
         * Scale the initial dimensions to a specific measurement.
         *
         * The result is a Gdk.Rectangle, as by default the aspect_ration is
         * maintained and the result is centered in the given space.
         *
         * By default the given scaling will not cut off any information of the
         * source size. The allow_cutoff parameter allows to maximize usage of
         * the given space by allowing to cut off certain parts of the initial
         * input.
         */
void pdfpc_scaler_scale_to (pdfpcScaler* self, gint width, gint height, gboolean centered, gboolean allow_cutoff, GdkRectangle* result) {
	GdkRectangle target = {0};
	gdouble factor = 0.0;
	gint _tmp0_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gboolean _tmp23_;
#line 62 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	g_return_if_fail (self != NULL);
#line 63 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	memset (&target, 0, sizeof (GdkRectangle));
#line 64 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	factor = (gdouble) 1.0f;
#line 65 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp0_ = width;
#line 65 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	if (_tmp0_ == 0) {
#line 114 "scaler.c"
		gint _tmp1_;
		gdouble _tmp2_;
#line 66 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp1_ = height;
#line 66 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp2_ = self->initial_height;
#line 66 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		factor = _tmp1_ / _tmp2_;
#line 123 "scaler.c"
	} else {
		gint _tmp3_;
#line 67 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp3_ = height;
#line 67 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		if (_tmp3_ == 0) {
#line 130 "scaler.c"
			gint _tmp4_;
			gdouble _tmp5_;
#line 68 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
			_tmp4_ = width;
#line 68 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
			_tmp5_ = self->initial_width;
#line 68 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
			factor = _tmp4_ / _tmp5_;
#line 139 "scaler.c"
		} else {
			gboolean _tmp6_;
#line 69 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
			_tmp6_ = allow_cutoff;
#line 69 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
			if (_tmp6_ == TRUE) {
#line 146 "scaler.c"
				gint _tmp7_;
				gdouble _tmp8_;
				gint _tmp9_;
				gdouble _tmp10_;
				gdouble _tmp11_;
#line 70 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp7_ = width;
#line 70 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp8_ = self->initial_width;
#line 70 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp9_ = height;
#line 70 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp10_ = self->initial_height;
#line 70 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp11_ = fmax (_tmp7_ / _tmp8_, _tmp9_ / _tmp10_);
#line 70 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				factor = _tmp11_;
#line 164 "scaler.c"
			} else {
				gint _tmp12_;
				gdouble _tmp13_;
				gint _tmp14_;
				gdouble _tmp15_;
				gdouble _tmp16_;
#line 76 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp12_ = width;
#line 76 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp13_ = self->initial_width;
#line 76 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp14_ = height;
#line 76 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp15_ = self->initial_height;
#line 76 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				_tmp16_ = fmin (_tmp12_ / _tmp13_, _tmp14_ / _tmp15_);
#line 76 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
				factor = _tmp16_;
#line 183 "scaler.c"
			}
		}
	}
#line 82 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp17_ = self->initial_width;
#line 82 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp18_ = factor;
#line 82 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp19_ = floor (_tmp17_ * _tmp18_);
#line 82 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	target.width = (gint) _tmp19_;
#line 83 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp20_ = self->initial_height;
#line 83 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp21_ = factor;
#line 83 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp22_ = floor (_tmp20_ * _tmp21_);
#line 83 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	target.height = (gint) _tmp22_;
#line 85 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	_tmp23_ = centered;
#line 85 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	if (_tmp23_ == TRUE) {
#line 207 "scaler.c"
		gint _tmp24_;
		GdkRectangle _tmp25_;
		gint _tmp26_;
		gdouble _tmp27_;
		gint _tmp28_;
		GdkRectangle _tmp29_;
		gint _tmp30_;
		gdouble _tmp31_;
#line 86 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp24_ = width;
#line 86 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp25_ = target;
#line 86 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp26_ = _tmp25_.width;
#line 86 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp27_ = floor ((gdouble) ((_tmp24_ - _tmp26_) / 2.0f));
#line 86 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		target.x = (gint) _tmp27_;
#line 87 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp28_ = height;
#line 87 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp29_ = target;
#line 87 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp30_ = _tmp29_.height;
#line 87 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		_tmp31_ = floor ((gdouble) ((_tmp28_ - _tmp30_) / 2.0f));
#line 87 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
		target.y = (gint) _tmp31_;
#line 236 "scaler.c"
	}
#line 90 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	*result = target;
#line 90 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	return;
#line 242 "scaler.c"
}


static void pdfpc_scaler_class_init (pdfpcScalerClass * klass) {
#line 32 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	pdfpc_scaler_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	G_OBJECT_CLASS (klass)->finalize = pdfpc_scaler_finalize;
#line 251 "scaler.c"
}


static void pdfpc_scaler_instance_init (pdfpcScaler * self) {
}


static void pdfpc_scaler_finalize (GObject * obj) {
	pdfpcScaler * self;
#line 32 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PDFPC_TYPE_SCALER, pdfpcScaler);
#line 32 "/builddir/build/BUILD/pdfpc-4.1.2/src/classes/scaler.vala"
	G_OBJECT_CLASS (pdfpc_scaler_parent_class)->finalize (obj);
#line 265 "scaler.c"
}


/**
     * Scaling calculator which is able to calculate different scaling
     * scenarios while maintaining the correct aspect ratio.
     */
GType pdfpc_scaler_get_type (void) {
	static volatile gsize pdfpc_scaler_type_id__volatile = 0;
	if (g_once_init_enter (&pdfpc_scaler_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (pdfpcScalerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pdfpc_scaler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (pdfpcScaler), 0, (GInstanceInitFunc) pdfpc_scaler_instance_init, NULL };
		GType pdfpc_scaler_type_id;
		pdfpc_scaler_type_id = g_type_register_static (G_TYPE_OBJECT, "pdfpcScaler", &g_define_type_info, 0);
		g_once_init_leave (&pdfpc_scaler_type_id__volatile, pdfpc_scaler_type_id);
	}
	return pdfpc_scaler_type_id__volatile;
}



